hdu 5067 Harry And Dig Machine (状态压缩dp)

题目链接

bc上的一道题,刚开始想用这个方法做的,因为刚刚做了一个类似的题,但是想到这只是bc的第二题,

以为用bfs水一下就过去了,结果MLE了,因为bfs的队列里的状态太多了,耗内存太厉害。

题意:

从某一点出发,遍历网格上的一些点,每个点至少访问一次需要的最小时间是多少。

官方题解:

由于Harry的dig machine是无限大的,而装载石头和卸载石头是不费时间的,所以问题可以转化成:从某一点出发,遍历网格上的一些点,每个点至少访问一次需要的最小时间是多少。这就是经典的旅行商问题,考虑到我们必须要遍历的点只有不到10个,可以用状态压缩解决。
Dp[i][j]表示i状态的点被访问过了,当前停留在点j 需要的最少时间。枚举另一点不在i状态内的点k,从点j节点走向点k,状态转移
Dp[i|(1?k)][k]=min(Dp[i|(1?k)][k],Dp[i][j]+Dis(j,k))
其中Dis(j,k)表示点j与点k的最短距离,这个可以通过坐标O(1)计算得到。若有t个点包含石头,则算法复杂度为O(n∗m+(t2)∗(2t))。
 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cmath>
 4 #include <queue>
 5 #include <cstring>
 6 #include <cstdlib>
 7 #include <algorithm>
 8 #define LL __int64
 9 #define INF 0x3f3f3f3f
10 const int maxn = 50+10;
11 using namespace std;
12 struct node
13 {
14     int x, y;
15 } p[maxn];
16 int a[maxn][maxn], c[maxn][maxn], d[(1<<11)+10][15];
17
18 int main()
19 {
20     int i, j, k, n, m, cnt;
21     while(~scanf("%d%d", &n, &m))
22     {
23         memset(d, INF, sizeof(d));
24         cnt = 0;
25         for(i = 0; i < n; i++)
26             for(j = 0; j < m; j++)
27             {
28                 scanf("%d", &a[i][j]);
29                 if(i == 0 && j == 0)
30                 {
31                     p[cnt].x = i;
32                     p[cnt++].y = j;
33                 }
34                 else if(a[i][j]>0)
35                 {
36                     p[cnt].x = i;
37                     p[cnt++].y = j;
38                 }
39             }
40         for(i = 0; i < cnt; i++)
41         {
42             for(j = i+1; j < cnt; j++)
43             {
44                 c[i][j] = c[j][i] = abs(p[i].x-p[j].x)+abs(p[i].y-p[j].y);
45             }
46             c[i][i] = 0;
47         }
48         d[0][0] = 0;
49         for(i = 0; i < (1<<cnt); i++)
50         {
51             for(j = 0; j < cnt; j++)
52                 if(d[i][j]!=INF)  //注意保证该状态存在
53                     for(k = 0; k < cnt; k++)
54                     {
55                         if(i&(1<<k)) continue;  //注意保证该点还没有加入
56                         if(c[j][k]==INF) continue;  //两个点之间可达
57                         d[i|(1<<k)][k] = min(d[i|(1<<k)][k], d[i][j]+c[j][k]);
58                     }
59         }
60         int ans = INF;
61         for(i = 0; i < cnt; i++)
62             ans = min(d[(1<<cnt)-1][i]+c[0][i], ans);
63         cout<<ans<<endl;
64     }
65     return 0;
66 }
时间: 2024-10-11 19:52:58

hdu 5067 Harry And Dig Machine (状态压缩dp)的相关文章

HDU 5067 Harry And Dig Machine(状压dp)

感觉这两天怎么老是遇到状压啊.... 数字20以下,首想状压啊... 不过这题犯抽忘记考虑没有石头的时候了啊. 简单的状压:表示状态为j时以第i的作为结束. PS:这题也在表扬大蓝翔的挖掘机技术啊.醉了啊... Harry And Dig Machine Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 468    Accepted S

HDU 5067 Harry And Dig Machine(状压DP)(TSP问题)

题目地址:pid=5067">HDU 5067 经典的TSP旅行商问题模型. 状压DP. 先分别预处理出来每两个石子堆的距离.然后将题目转化成10个城市每一个城市至少经过一次的最短时间模型.然后简单的状压DP就可以. 代码例如以下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #incl

HDU 5067 Harry And Dig Machine(状压dp)

HDU 5067 Harry And Dig Machine 思路:由于点才10个,在加上一个起点,处理出每个点之间的曼哈顿距离,然后用状压dp搞,状态表示为: dp[i][s],表示在i位置,走过的点集合为s的最小代价 代码: #include <cstdio> #include <cstring> #include <cstdlib> #include <algorithm> using namespace std; const int N = 15;

HDU 3001 Travelling (三进制状态压缩 DP)

题意:有 n 个city,可以选择任一城市作为起点,每个城市不能访问超过2次, 城市之间有权值,问访问全部n个城市需要的最小权值. 思路:因为每个城市可以访问最多两次,所以用三进制表示访问的状态. 详细见代码注释!!!! #include<cstdio> #include<stdlib.h> #include<string.h> #include<string> #include<map> #include<cmath> #inclu

HDU - 5067 Harry And Dig Machine (bfs + 状态压缩)

题目大意:有一个n*m的网格,网格上面有k个地方有石头,现在要求从左上角出发,遍历所有有石头的地方,然后回到左上角,问最短距离是多少 解题思路:因为石头的总数小于等于10,所以可以进行压缩 设dp[i][j][state]表示在(i,j)位置,遍历的石头状态为state,走的最小距离,直接bfs即可 #include <cstdio> #include <cstring> #include <algorithm> #include <map> #includ

HDU 5067 Harry And Dig Machine

Harry And Dig Machine Time Limit: 1000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 506764-bit integer IO format: %I64d      Java class name: Main As we all know, Harry Porter learns magic at Hogwarts School. However, lear

hdu 5067 Harry And Dig Machine(BestCoder Round #14)

Harry And Dig Machine Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 332    Accepted Submission(s): 104 Problem Description As we all know, Harry Porter learns magic at Hogwarts School. Howeve

HDU 5067 Harry And Dig Machine(BestCoder Round #14)

Problem Description: As we all know, Harry Porter learns magic at Hogwarts School. However, learning magical knowledge alone is insufficient to become a great magician. Sometimes, Harry also has to gain knowledge from other certain subjects, such as

HDU 5418 Victor and World (状态压缩dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5418 题目大意:有n个结点m条边(有边权)组成的一张连通图(n <16, m<100000).求从第一个点出发,经过每个点至少一次后回到原点的最小路径边权和. 分析:发现我还真是菜. n<16,很明显的状态压缩标记,先将所有点的编号减去1,使其从0开始编号.dp[i][j]表示从0号点出发,当前状态为i (二进制位为1表示对应点已走过,否则没走过), 当前位置为 j,  回到原点的最小代价,